; Drive the explosions/implosions

Top_Y		equ Min_Y		; Top of screen

; Add an explosion

Gen_Frag:	push di			; Save

		; Giz some space

		call Get_Free		; Giz some space
		jc GF_X			; Failed, exit

		; No move routine

		mov cx,0		; No routine

		; As for warp in

		call Warp_In		; Warp it out

		; Done

GF_X:		pop di			; Restore
		ret			;

	; Setup a warp-in, given ax = X, dl = Y, bx = Table, cx = Add_Routine

Warp_In:	call Add_Frag		; Add this new fragment

		; Clear the clipping window

		mov b cs:dTop[di],0	; 0
		mov b cs:dBott[di],0	;

		; Store them

		mov cs:d_X[di],ax	; X
		mov cs:d_Y[di],dl	; Y

		; Set the table

		mov cs:dfTab[di],bx	; Save it

		; Set the movement routine

		mov cs:dpMove[di],cx	; Move routine

		; Set its flags

		mov b cs:dFlags[di],0	; It's alive

		; Clear the map data

		mov w cs:dMap_Ptr[di],0	; Nothing

		; Done, exit

		ret			; Done

; Show the fragments

Drive_Frags:	mov dx,3CEh		; Graphics controller

		mov ax,00A05h		; Mode/Reg
		out dx,ax		; Set it

		; Set the colour don't care register

		mov ax,00F07h		; CDC := 0F
		out dx,ax		;

		; Set the colour compare register

		; This selects the colour used for collisions

		mov ax,00202h		; CMP := 02
		out dx,ax		;

		; Set the function to replace

		mov ax,00003h		; DRF := 0
		out dx,ax		;

		; Terminate the un-draw

		dec bp			; Move it
		dec bp			;

		mov w cs:[bp],0		; Save term

		; Show the fragments

		mov di,cs:pFrags	; Point at the fragment list

		mov ax,o pFrags-dpNext	; Point at this ptr
		mov cs:pPrev_Thing,ax	; Save this

		cmp di,0		; Any things ?
		jz DF_X			; No, exit

		; Set the explosion frequency

		mov ax,868		; F
		call Set_Freq		; Set it

		; Loop

DF_Lp:		call Spk_Off		; Kill the sound

		cmp di,0		; Valid ?
		jz DF_X			; No, skip

		; Now, get the next colour

		mov bx,cs:dfTab[di]	; Point at the table

		mov ax,cs:[bx]		; Get the offset/colour

		cmp ax,0		; End ?
		je DF_End		; Yes, exit

		inc bx			;
		inc bx			;

		mov cs:dfTab[di],bx	; Save next ptr

		; Now show this fragment

		call Move_Frag		; Move it

		; Move onto the next

DF_Next:	mov cs:pPrev_Thing,di	; Save a ptr to it

		mov di,cs:dpNext[di]	; Next thing

		jmp s DF_Lp		; Loop

	; Exit code, setup the un-draw operation

DF_X:		mov ax,cs:VDU_Seg	; Get the seg
		mov cs:-2[bp],ax	; Ptr to screen for the un-draw

		mov w cs:-4[bp],o UD_Frag; Routine for the undraw

		add bp,-4		; Move ptr

		ret			; Done

	; We must kill this fragment

DF_End:		mov ax,cs:dpNext[di]	; The next one
		mov bx,cs:pPrev_Thing	; The last one

		mov cs:dpNext[bx],ax	; The last points at the next

		; Now, is this a warp-in ?

		test w cs:dpMove[di],-1	; Any move routine ?
		jnz DFE_Add		; Yes, add to the thing list

		; Add this one to free-space

		call Put_Free		; Release di

		; Now, drive the next one

		mov di,ax		; Point at the next one

		jmp s DF_Lp		; Loop

	; Add this to the list of things

DFE_Add:	push ax			; Save ptr

		call Add_Thing		; Add this as a thing

		pop di			; Point at the next fragment

		jmp s DF_Lp		; Loop

; Entry with di pointing at data, al = disp ah = colour; show the 8 fragments

Move_Frag:	mov dl,al		; Save the disp/colour
		mov dh,0		; dx = disp

		mov cs:MF_Col,ah	; Save the colour

		; Get the X's

		mov ax,cs:Scr_X		; LHS's X
		mov bx,cs:d_X[di]	; Thing's real X

		call Calc_Offset	; ax := difference

		mov bx,ax		; Save the center X

		; Calc the LHS X

		mov w cs:MF_LHS_XO,-1	; Assume not valid

		sub ax,dx		; Move left

		; Is this valid ?

		cmp ax,320		; In range ?
		jnc MF_1		; No, skip

		; Yes, get X offset and bit-map

		mov cl,al		; Save bit-map

		shr ax,1		; Calc offset
		shr ax,1		; Calc offset
		shr ax,1		; Calc offset

		mov cs:MF_LHS_XO,ax	; Save it

		and cl,06h		; Mask rotate value

		mov al,0C0h		; Bit-mask
		shr al,cl		; Align

		mov cs:MF_LHS_XM,al	; Save it

		; Now do the centre

MF_1:		mov ax,bx		; Get the center X

		; Calc the CEN X

		mov w cs:MF_CEN_XO,0	; Assume not valid

		; Is this valid ?

		cmp ax,320		; In range ?
		jnc MF_2		; No, skip

		; Yes, get X offset and bit-map

		mov cl,al		; Save bit-map

		shr ax,1		; Calc offset
		shr ax,1		; Calc offset
		shr ax,1		; Calc offset

		mov cs:MF_CEN_XO,ax	; Save it

		and cl,06h		; Mask rotate value

		mov al,0C0h		; Bit-mask
		shr al,cl		; Align

		mov cs:MF_CEN_XM,al	; Save it

		; Now do the RHS

MF_2:		mov ax,bx		; Get the center X
		add ax,dx		; RHS

		; Calc the RHS X

		mov w cs:MF_RHS_XO,0	; Assume not valid

		; Is this valid ?

		cmp ax,320		; In range ?
		jnc MF_3		; No, skip

		; Yes, get X offset and bit-map

		mov cl,al		; Save bit-map

		shr ax,1		; Calc offset
		shr ax,1		; Calc offset
		shr ax,1		; Calc offset

		mov cs:MF_RHS_XO,ax	; Save it

		and cl,06h		; Mask rotate value

		mov al,0C0h		; Bit-mask
		shr al,cl		; Align

		mov cs:MF_RHS_XM,al	; Save it

		; Now do the Y's

MF_3:		mov w cs:MF_TOP,0	; Assume none
		mov w cs:MF_MID,0	;
		mov w cs:MF_BOT,0	;

		; Calc top
	
		mov al,cs:d_Y[di]	; Y

		sub al,dl		; Up

		cmp al,200		; In range ?
		jae MF_4		; No, this cannot be seen

		cmp al,Top_Y		; In range ?
		jb MF_4			; No, this cannot be seen

		; Now, calc the display ptr, clip value, offset etc

		mov ah,0		; 0 .. 255

		push dx			; Save

		mov dx,cs:VDU_Width	; Display YStep
		mul dx			; ax := Address fn(Y)

		pop dx			; Restore

		add ax,cs:VDU_Offset	;

		mov cs:MF_TOP,ax	; Save

		; Calc mid
	
MF_4:		mov al,cs:d_Y[di]	; Y

		cmp al,200		; In range ?
		jae MF_5		; No, this cannot be seen

		cmp al,Top_Y		; In range ?
		jb MF_5			; No, this cannot be seen

		; Now, calc the display ptr, clip value, offset etc

		mov ah,0		; 0 .. 255

		push dx			; Save

		mov dx,cs:VDU_Width	; Display YStep
		mul dx			; ax := Address fn(Y)

		pop dx			; Restore

		add ax,cs:VDU_Offset	;

		mov cs:MF_MID,ax	; Save

		; Calc bot
	
MF_5:		mov al,cs:d_Y[di]	; Y

		add al,dl		; Down

		cmp al,200		; In range ?
		jae MF_6		; No, this cannot be seen

		cmp al,Top_Y		; In range ?
		jb MF_6			; No, this cannot be seen

		; Start the sounds

		push ax
		call Spk_On		; Set it
		pop ax

		; Now, calc the display ptr, clip value, offset etc

		mov ah,0		; 0 .. 255

		push dx			; Save

		mov dx,cs:VDU_Width	; Display YStep
		mul dx			; ax := Address fn(Y)

		pop dx			; Restore

		add ax,cs:VDU_Offset	;

		mov cs:MF_BOT,ax	; Bott

		; Show them, setup the vdu regs

MF_6:		mov ax,cs:VDU_Seg	; Point at the VDU
		mov ds,ax		; Use DS

		; Setup the VDU regs

		mov dx,3CEh		; Graphics controller
		mov al,8		; Bit-mask register

		; Now, LHS

		mov cx,cs:MF_LHS_XO	; Giz offset
		cmp cx,-1		; None ?
		jz MF_7			; No, skip

		; Set the bit-mask

		mov ah,cs:MF_LHS_XM	; Mask
		out dx,ax		; Set the register

		mov ah,cs:MF_Col	; Colour

		; TOP

		mov bx,cs:MF_TOP	; Giz addr
		cmp bx,0		; None ?
		jz MF_6a		; No, skip

		; Do it

		add bx,cx		; Add X

		or [bx],ah		; Show it

		; Save this for the un-draw operation

		dec bp			; Move it
		dec bp			;

		mov cs:[bp],bx		; Save ptr

		; Try middle

MF_6a:		mov bx,cs:MF_MID	; Giz addr
		cmp bx,0		; None ?
		jz MF_6b		; No, skip

		; Do it

		add bx,cx		; Add X
		or [bx],ah		; White
;		or Y_Step[bx],ah	;

		; Save this for the un-draw operation

		dec bp			; Move it
		dec bp			;

		mov cs:[bp],bx		; Save ptr

MF_6b:		mov bx,cs:MF_BOT	; Giz addr
		cmp bx,0		; None ?
		jz MF_7			; No, skip

		; Do it

		add bx,cx		; Add X

		or [bx],ah		; 
;		or Y_Step[bx],ah	;

		; Save this for the un-draw operation

		dec bp			; Move it
		dec bp			;

		mov cs:[bp],bx		; Save ptr

		; Now, MIDDLE

MF_7:		mov cx,cs:MF_CEN_XO	; Giz offset
		cmp cx,0		; None ?
		jz MF_8			; No, skip

		; Set the bit-mask

		mov ah,cs:MF_CEN_XM	; Mask
		out dx,ax		; Set the register

		mov ah,cs:MF_Col	; Colour

		; TOP

		mov bx,cs:MF_TOP	; Giz addr
		cmp bx,0		; None ?
		jz MF_7a		; No, skip

		; Do it

		add bx,cx		; Add X
		or [bx],ah		; White
;		or Y_Step[bx],ah	;

		; Save this for the un-draw operation

		dec bp			; Move it
		dec bp			;

		mov cs:[bp],bx		; Save ptr

		; Ignore the middle, skip to bott

MF_7a:		mov bx,cs:MF_BOT	; Giz addr
		cmp bx,0		; None ?
		jz MF_8			; No, skip

		; Do it

		add bx,cx		; Add X
		or [bx],ah		; White
;		or Y_Step[bx],ah	;

		; Save this for the un-draw operation

		dec bp			; Move it
		dec bp			;

		mov cs:[bp],bx		; Save ptr

		; Now, RHS

MF_8:		mov cx,cs:MF_RHS_XO	; Giz offset
		cmp cx,0		; None ?
		jz MF_9			; No, skip

		; Set the bit-mask

		mov ah,cs:MF_RHS_XM	; Mask
		out dx,ax		; Set the register

		mov ah,cs:MF_Col	; Colour

		; TOP

		mov bx,cs:MF_TOP	; Giz addr
		cmp bx,0		; None ?
		jz MF_8a		; No, skip

		; Do it

		add bx,cx		; Add X
		or [bx],ah		; 
;		or Y_Step[bx],ah	;

		; Save this for the un-draw operation

		dec bp			; Move it
		dec bp			;

		mov cs:[bp],bx		; Save ptr

		; Try middle

MF_8a:		mov bx,cs:MF_MID	; Giz addr
		cmp bx,0		; None ?
		jz MF_8b		; No, skip

		; Do it

		add bx,cx		; Add X
		or [bx],ah		; White
;		or Y_Step[bx],ah	;

		; Save this for the un-draw operation

		dec bp			; Move it
		dec bp			;

		mov cs:[bp],bx		; Save ptr

MF_8b:		mov bx,cs:MF_BOT	; Giz addr
		cmp bx,0		; None ?
		jz MF_9			; No, skip

		; Do it

		add bx,cx		; Add X
		or [bx],ah		; White
;		or Y_Step[bx],ah	;

		; Save this for the un-draw operation

		dec bp			; Move it
		dec bp			;

		mov cs:[bp],bx		; Save ptr

		; All done, exit

MF_9:		ret			; Done

; Undraw the fragment, using the info. from the undraw stack.

UD_Frag:	pop ds			; Get the segment

		; Setup the required EGA modes, urgh !

		; Set Write mode 0, Read-mode 1

		mov dx,3CEh		; Graphics controller
		mov ax,00805h		; Mode/Reg
		out dx,ax		; Set it

		; Set the colour don't care register

		mov ax,00007h		; CDC := 0
		out dx,ax		;

		; Set the function to replace

		mov ax,00003h		; DRF := 0
		out dx,ax		;

		; Set the Enable Set/Reset to pass the Set/Reset bits

		mov ax,00F01h		; ESR := 0F
		out dx,ax		;

		; Now set the required colour

		mov ax,00000h		; Colour = 00 into Set/Reset
		out dx,ax		;

		; Now set the bit mask

		mov ax,0FF08h		; Mask = FF
		out dx,ax		;

		; Undraw them

UF_Lp:		pop bx			; Get the pixel address
		mov [bx],al		; Clear it, all 8 pixels
;		mov Y_Step[bx],al	;

		cmp bx,0		; End ?
		jnz UF_Lp		; No, loop

		; Done, undrawn !

		ret			; Goto the next undraw routine

; Fixed data

Frag_Implode	db 42, 4		; Offset / colour
		db 42, 4		;
		db 42, 4		;
		db 42, 4		;
		db 42, 4		;
		db 42, 4		;
		db 42, 4		;
		db 42, 4		;
		db 42, 4		;

		db 41, 5		;
		db 41, 5		;
		db 41, 5		;
		db 41, 5		;
		db 41, 5		;
		db 41, 5		;
		db 41, 5		;
		db 41, 5		;
		db 41, 5		;

		db 40, 6		;
		db 40, 6		;
		db 40, 6		;
		db 40, 6		;
		db 40, 6		;
		db 40, 6		;
		db 40, 6		;
		db 40, 6		;

		db 39, 7		;
		db 39, 7		;
		db 39, 7		;
		db 39, 7		;
		db 39, 7		;
		db 39, 7		;
		db 39, 7		;

		db 38, 9		;
		db 38, 9		;
		db 38, 9		;
		db 38, 9		;
		db 38, 9		;
		db 38, 9		;

		db 37, 9		;
		db 37, 9		;
		db 37, 9		;
		db 37, 9		;
		db 37, 9		;

		db 36,10		;
		db 36,10		;
		db 36,10		;
		db 36,10		;

		db 35,10		;
		db 35,10		;
		db 35,10		;

		db 34,11		;
		db 34,11		;

		db 33,11		;

		db 32,12		;

		db 31,12		;

		db 30,13		;
		db 29, 7		;
		db 28, 9		;
		db 27, 9		;
		db 26,10		;
		db 24,11		;
		db 23,11		;
		db 22,12		;
		db 20, 6		;

		db 19, 7		;
		db 18, 9		;
		db 16,10		;
		db 15,10		;
		db 13,11		;
		db 12,12		;
		db 10, 6		;

		db  9, 7		;
		db  7, 9		;
		db  5,10		;
		db  3,11		;
		db  1,12		;

		db  0, 0		;

Frag_Explode	db  0,15		;
		db  5,15		; Offset / colour
		db 10,15		;
		db 15,15		;
		db 19,14		;
		db 23,14		;
		db 27,13		;
		db 30,13		;
		db 33,12		;
		db 36,11		;
		db 38,10		;
		db 40, 9		;
		db 42, 7		;
		db 44, 7		;
		db 46, 6		;
		db 48, 5		;
		db 50, 4		;
		db 52, 3		;
		db 54, 2		;
		db 56, 1		;
		db  0, 0		;

Frag_Explode_S	db  1,15		; Offset / colour
		db  3,15		;
		db  5,14		;

		db  1,15		;
		db  7,14		;

		db  3,15		;
		db  9,13		;

		db  5,14		;
		db 11,13		;

		db  7,14		;
		db 14,12		;

		db  9,13		;
		db 17,12		;

		db 11,13		;
		db 19,11		;

		db 12,12		;
		db 21,11		;

		db  0, 0		;

Frag_Explode_SS	db  1,15		; Offset / colour
		db  3,15		;
		db  5,14		;

		db  1,15		;
		db  7,14		;

		db  3,15		;
		db  9,13		;

		db  0, 0		; End

Frag_Explode_B	db  1,15		; Offset / colour
		db  3,14		;
		db  6,13		;

		db  1, 7		;
		db  9,12		;

		db  3, 6		;
		db 11,11		;

		db  6, 5		;
		db 13,10		;

		db  9, 4		;
		db 15, 9		;

		db  0, 0		; End

; Vars

MF_LHS_XO	dw 0			;
MF_LHS_XM	db 0			;

MF_CEN_XO	dw 0			;
MF_CEN_XM	db 0			;

MF_RHS_XO	dw 0			;
MF_RHS_XM	db 0			;

MF_TOP		dw 0			;
MF_MID		dw 0			;
MF_BOT		dw 0			;

MF_Col		db 0			;
