; The various option bytes

Option_Bytes	equ this byte

optShowName	db 1	,1	,255	,"  "	; Show option name

optShipBurn	db 0	,0	,1	,"SB"	; Ship burns slowly

optExplo_Cnt	db 80	,1	,255	,"EC"	; Explosion fragments
optExplo_Life	db 100	,1	,255	,"EL"	; Explosion life
optExpl_Grav	db 15	,0	,255	,"EG"	; Gravity

opt_4_Cnt	db 4	,1	,100	,"4C"	; This many things per '4'

optSmart_Rate	db 5	,0	,64	,"SR"	; Smart bomb penalty

optSFC		db 4	,1	,10	,"SF"	; Ship's fire rate
optLas_Life	db 26	,1	,255	,"LL"	; Ships laser life

optProj_Life	db 25	,1	,255	,"PL"	; Lifetime of projectile (/4)

optLFP		db 10	,1	,200	,"LF"	; Lander fire prob
optLPS		db 500/16,1	,255	,"LV"	; Proj speed
optMFP		db 20	,1	,200	,"MF"	; Mutant fire prob
optMPS		db 800/16,1	,255	,"MV"	; Proj speed
optBFP		db 6	,1	,200	,"BF"	; Baiter fire prob
optBPS		db 600/16,1	,255	,"BV"	; Proj speed

optMuta_Look	db 10	,1	,255	,"ML"	; Mutant look rate
optMuta_Turn	db 3	,1	,32	,"MT"	; Mutant look rate

optBait_D_R	db 26	,1	,255	,"BD"	; Bait direction rate
optBait_T	db 6	,1	,32	,"BT"	; Bait turn rate

optPod_D_R	db 20	,1	,255	,"PD"	; Pod dir rate
optPod_T	db 6	,1	,32	,"PT"	; Pod turn rate
optPod_Sp	db 180/16,1	,255	,"PS"	; Pod speed

optSwarm_D_R	db 15	,1	,255	,"SD"	; Swarmer dir rate
optSwarm_T	db 5	,1	,32	,"ST"	; Swarmer turn rate
optSwarm_Sp	db 1030/16,1	,255	,"SS"	; Swarmer speed

optBomb_Rate	db 27	,1	,255	,"BR"	; Bombing rate
optBomb_Cnt	db 40	,1	,200	,"BC"	; This many
optBomb_Life	db 900/16,1	,200	,"BL"	; Bomb life

nSwarmers	db 20	,1	,255	,"nS"	; Pods become this many swarmers

Initial_Level	db 1	,1	,12	,"iL"	; Starting level

optMen		db 6	,0	,100	,"iM"	; Number of men

optRescue_Shield db 10	,1	,63	,"RS"	; Rescue man shield bonus

Option_B_End	equ this byte

	; Now we have the other saveable options

nOption		db 0			; The current option number

Noise_F		db 0;-1			; Starts off
Difficulty	db 1			; Medium/Hard/Impossible
Language	db 0			; Ass/C++/C/BASIC
Lang_Vis_F	db 0			; Language visible flag

	; End here

All_Opt_End	equ this byte

; Calculate full values

Calc_Options:	mov al,cs:optLPS	; Lander proj speed
		call CO_Conv		; Convert
		mov cs:Land_Proj_Sp,ax	; Save

		mov al,cs:optMPS	;
		call CO_Conv		;
		mov cs:Muta_Proj_Sp,ax	;

		mov al,cs:optBPS	;
		call CO_Conv		;
		mov cs:Bait_Proj_Sp,ax	;

		mov al,cs:optPod_Sp	;
		call CO_Conv		;
		mov cs:Pod_Speed,ax	;

		mov al,cs:optSwarm_Sp	;
		call CO_Conv		;
		mov cs:Swarm_Speed,ax	;

		mov al,cs:optBomb_Life	;
		call CO_Conv		;
		mov cs:Bomb_Life,ax	;

		ret			; Done

; Convert a byte to word

CO_Conv:	mov ah,0		; 16-bit

		mov cl,4		; * 16
		rol ax,cl		;

		ret			; Done

; Vars

Land_Proj_Sp	dw ?			; Vars
Muta_Proj_Sp	dw ?			;
Bait_Proj_Sp	dw ?			;

Pod_Speed	dw ?			;
Swarm_Speed	dw ?			;

Bomb_Life	dw ?			;
