; These drive the pods and swarmers

Pod_Score	equ 10			; Score for pod

Pod_Hits	equ 4			; Hit counts
Swarmer_Hits	equ 1			;

Pod_Damage	equ 0			; Damage if collision
Swarmer_Damage	equ 1			;

; Add one thing to the list

Create_1_Pod:	call Get_Free		; DI := ptr to free space
		jc C1P_Fail		; Failed

		; Now create a thing

		call Create_Pod		; Do it

		; Done, exit

C1P_Fail:	ret			; Done

; Generate a pod

Create_Pod:	mov b cs:dSpeed[di],1	; Frame-rate
		mov b cs:dDelay[di],1	; Start immediately

		; Setup its shape

		mov b cs:dShape[di],24	; Thing sprite

		; Setup colours

		mov ax,0B09h		; Col 0,1
		mov cs:dCol1[di],ax	;

		mov ax,0F07h		; Col 2,3
		mov cs:dCol2[di],ax	;

		mov b cs:dMap_Col[di],B_Green ; Colour in map

		; Setup the dirn change timer

		mov w cs:dLife[di],1	 ; Timer

		; Setup it's hit points

		mov b cs:dHits[di],Pod_Hits ; This many

		; Setup it's shot routine

		mov w cs:dpShot[di],o Pod_Shot; Shot routine

		; Speed

		mov ax,cs:Pod_Speed	; Speed
		mov cs:dTargSpeed[di],ax;

		; Vector

		mov w cs:ddX[di],0	; Not moving
		mov w cs:ddY[di],0	;

		; Position

		call Rand_X		; Giz a random X

		; Get its Y

		push ds			; Save
		push ax			;

		mov bx,o Mount_Ys	; Y defn
		add bx,ax		;

		mov ax,DATA		; Get the seg
		mov ds,ax		;

		mov dl,ds:[bx]		; Get the Y
		sub dl,5		; In the middle of the man

		pop ax			; Restore
		pop ds			;

		; Setup it's move routine

		mov cx,o Move_Pod	; Move routine

		; Setup it's implode

		mov bx,o Frag_Implode	; Implosion

		; Add it

		call Warp_In		; Warp it in

		; Exit

		ret			; Done

; Add one thing to the list

Create_1_Swarmer:call Get_Free		; DI := ptr to free space
		jc C1P_Fail		; Failed

		; Now create a thing

		call Create_Swarmer	; Do it

		; Done, exit

		ret			; Done

; Generate a swarmer

Create_Swarmer:	mov b cs:dSpeed[di],1	; Frame-rate
		mov b cs:dDelay[di],1	; Start immediately

		; Setup its shape

		mov b cs:dShape[di],25	; Thing sprite

		; Setup colours

		mov ax,0B09h		; Col 0,1
		mov cs:dCol1[di],ax	;

		mov b cs:dMap_Col[di],B_Magenta ; Colour in map

		; Setup the dirn change timer

		mov w cs:dLife[di],1	 ; Timer

		; Setup it's hit points

		mov b cs:dHits[di],Swarmer_Hits ; This many

		; Setup it's shot routine

		mov w cs:dpShot[di],o Thing_Shot; Shot routine

		; Speed

		call Rand_32		; Random
		and ah,03h		; 0 .. 1023
		add ax,cs:Swarm_Speed	; Speed
		mov cs:dTargSpeed[di],ax;

		; Vector

		call Rand_32		; Random
		cbw			; 16-bit

		add ax,ax		; * 8
		add ax,ax		;
		add ax,ax		;

		mov cs:ddX[di],ax	; Random move
		mov w cs:dTargdX,0	;

		mov al,ah		; /256
		cbw			;
		mov cx,ax		; Save 

		call Rand_32		;
		cbw			;

		add ax,ax		; * 8
		add ax,ax		;
		add ax,ax		;

		mov cs:ddY[di],ax	;
		mov w cs:dTargdY[di],0	;

		; Position

		mov dl,cs:Temp_Y	; Giz Y
		add dl,ah		; Move

		mov ax,cs:Temp_X	; Giz X
		add ax,cx		; Move it
		call Wrap_X		; Clip

		; Setup it's move routine

		mov cx,o Move_Swarmer	; Move routine

		; Setup it's implode

		mov bx,o NoFrag		; Implosion

		; Add it

		call Warp_In		; Warp it in

		; Exit

		ret			; Done

; Immediate warp in

NoFrag		db 1,1			; Colour
		db 0,0			;

; Pod shot

Pod_Shot:	dec b cs:dCol1+1[si]	; Change

		jmp Thing_Shot		; As normal

; Pod killed

MPD_Shot:	mov ax,Pod_Score	; Score
		call Add_Score		;

		push di

		mov ax,cs:d_X[di]	;
		mov cs:Temp_X,ax	;
		mov al,cs:d_Y[di]	;
		mov cs:Temp_Y,al	;

		mov cl,cs:nSwarmers	; This many (OPTION)
		mov ch,0		;

MPDS_Lp:	push cx			; Save
		call Create_1_Swarmer	; One more
		pop cx			;

		loop MPDS_Lp		; Loop

		pop di			; Restore

		jmp MT_Shot		; Vector off

; Vectors

vMPD_PossHit:	jmp MPD_PossHit		; Vector
vMPD_NewDir:	jmp MPD_NewDir		;

; Move a pod

Move_Pod:	test b cs:dFlags[di],080h; Hit ?
		jnz MPD_Shot		 ; Yes, skip

		; Have we hit the ship ?

		mov al,cs:Ship_Y	; The ship's Y
		sub al,3		; Widen it
		cmp al,cs:dBott[di]	; Get the highest possible Y
		jb vMPD_PossHit		; Yes, possible hit

		; Change dirn ?

MPD_NotHit:	mov ax,cs:dLife[di]	; Time to change dirn ?
		dec ax			;
		jz vMPD_NewDir		; Yes, skip

		mov cs:dLife[di],ax	; Save time

		; Change colour

		ror al,1		; Align
		ror al,1		;

		and al,02h		; 0/2
		add al,0Dh		; 

		mov cs:dCol2+1[di],al	; Store colour

		mov cs:dMap_Col[di],al	; Colour

	; Move it, using fractions

MPD_GotDir:	mov ax,cs:dTargdX[di]	; Target vector
		sub ax,cs:ddX[di]	; Current vector
		je MPD_GD_1		; Same, skip

		; Now, turn as a function of damage

		mov cl,Pod_Hits		; /n
		sub cl,cs:dHits[di]	;
		add cl,cs:optPod_T	;

		sar ax,cl		;
		jnz MPD_GD_0a		; Skip nz

		mov ax,1		; At least 1

MPD_GD_0a:	add cs:ddX[di],ax	; Change it

MPD_GD_1:	mov ax,cs:dTargdY[di]	; Target vector
		sub ax,cs:ddY[di]	; Current vector
		je MPD_GD_2		; Same, skip

		sar ax,cl		;
		jnz MPD_GD_1a		; Skip nz

		mov ax,1		; At least 1

MPD_GD_1a:	add cs:ddY[di],ax	; Change it

		; Now move

MPD_GD_2:	mov bl,cs:ddX[di]	; Step in X
		mov al,cs:ddX+1[di]	;
		cbw			;

		add bl,cs:d_frac_X[di]	; Add it
		adc ax,cs:d_X[di]	;

		mov cs:d_frac_X[di],bl	; Save fractional X

		call Wrap_X		; Clip it

		mov cs:d_X[di],ax	; Save new X

		; Move it in Y

		mov ax,cs:ddY[di]	; Disp
		add ax,cs:d_frac_Y[di]	; Posn

		mov cs:d_frac_Y[di],al	; Save fraction

		mov al,ah		; Y

		; Clip Y

		cmp al,Max_Y-6		; Below bottom ?
		ja MPD_Y_Top		; Above

		cmp al,Min_Y+6		; Above top ?
		jae MPD_Y		; No, skip

		mov al,Max_Y-6		; Bottom
		jmp s MPD_Y		; Yes

MPD_Y_Top:	mov al,Min_Y+6		; Clip

MPD_Y:		mov cs:d_Y[di],al	; Save pos

		; Save the clipping Y's

		add al,6		; Bottom
		mov cs:dBott[di],al	;

		sub al,6+6		; Top
		mov cs:dTop[di],al	;

		; Draw it, etc

		jmp MT_Show		; Show it

; Time to change direction

MPD_NewDir:	mov al,cs:optPod_D_R	; Time to change
		mov ah,0		;
		mov cs:dLife[di],ax	;

		; Now calc new vector
		; X

		mov bx,cs:Ship_X	; Target
		mov ax,cs:d_X[di]	; Our X
		call Calc_Offset	; Vector
		mov cx,ax		; Save
		mov si,ax		;

		; Y

		mov al,cs:Ship_Y	; Target
		sub al,cs:d_Y[di]	; Our 
		cbw			; 16-bit
		mov bx,ax		; Save dY

		; Now, we must scale these to get the required speed.

		cmp cx,0		; dX +ve ?
		jns MPD_ND_1		; Yes, skip

		neg cx			; Abs dX

MPD_ND_1:	cmp ax,0		; dY +ve ?
		jns MPD_ND_2		; Yes, skip

		neg ax			; Abs dX

MPD_ND_2:	add cx,ax		; |dx| + |dY|
		inc cx			; NOT 0 !

		; Calc the scale speed

		mov ah,cs:dHits[di]	; Target speed
		mov al,0		;
		shr ax,1		;
		add ax,cs:dTargSpeed[di]; Base speed

		mov dx,0		; 32-bit

		div cx			; Calc 

		; Now scale the real dX/dY

		mov cx,ax		; Scale factor
		inc cx			; NOT ZERO !

		mov ax,si		; dX
		imul cx			; Scale it
		mov cs:dTargdX[di],ax	;

		mov ax,bx		; dY
		imul cx			; Scale it
		mov cs:dTargdY[di],ax	;

		; Done, skip

		jmp MPD_GotDir		; As above

	; Possible impact with the ship

MPD_PossHit:	add al,3+3		; Down
		cmp al,cs:dTop[di]	; Get the highest possible Y
		jb vMPD_NotHit		; No, not hit

		; The Y's are right, check the X's

		mov ax,cs:Ship_X	; The ship's position

		sub ax,16		; Back 11
		call Wrap_X		;
		mov cx,ax		;

		mov ax,cs:Ship_X	; The ship's position

		add ax,16		; Back 11
		call Wrap_X		;
		mov dx,ax		;

		mov ax,cs:d_X[di]	; X in range ?

		cmp cx,dx		; Wrapped ?
		jnc MPDPH_CheckEnd	; Yes, try another clip

		; Now try the X's

		cmp ax,cx		;
		jb vMPD_NotHit		; No, fail

		cmp ax,dx		; X in range ?
		ja vMPD_NotHit		; No, fail

		; Assume a hit

MPD_Hit:	mov al,Pod_Damage	; Dec the shields
		call Shield_Dec		;

		; Explode the mine

		jmp MPD_Shot		; As if shot

	; The pod is at the end, alternate clip

MPDPH_CheckEnd:	cmp ax,dx		; X<RHS
		jb MPD_Hit		; Yes, skip

		cmp ax,cx		; LHS<X
		ja MPD_Hit		; Yes, skip 

		; Not hit, skip

vMPD_NotHit:	jmp MPD_NotHit		; Skip


; ----------------------------- SWARMERS

; Swarmer killed

MSW_Shot:	mov ax,Pod_Score	; Score
		call Add_Score		;

		jmp MT_Shot		; Vector off

; Vectors

vMSW_PossHit:	jmp MSW_PossHit		; Vector
vMSW_NewDir:	jmp MSW_NewDir		;

; Move a swarmer

Move_Swarmer:	test b cs:dFlags[di],080h; Hit ?
		jnz MSW_Shot		 ; Yes, skip

		; Have we hit the ship ?

		mov al,cs:Ship_Y	; The ship's Y
		sub al,3		; Widen it
		cmp al,cs:dBott[di]	; Get the highest possible Y
		jb vMSW_PossHit		; Yes, possible hit

		; Change dirn ?

MSW_NotHit:	mov ax,cs:dLife[di]	; Time to change dirn ?
		dec ax			;
		jz vMSW_NewDir		; Yes, skip

		mov cs:dLife[di],ax	; Save time

		; Change colour

		ror al,1		; Align
		ror al,1		;

		and al,02h		; 0/2
		add al,0Dh		; 

		mov cs:dCol2+1[di],al	; Store colour

	; Move it, using fractions

MSW_GotDir:	mov ax,cs:dTargdX[di]	; Target vector
		sub ax,cs:ddX[di]	; Current vector
		je MSW_GD_1		; Same, skip

		; Now, turn 

		mov cl,cs:optSwarm_T	;

		sar ax,cl		;
		jnz MSW_GD_0a		; Skip nz

		mov ax,1		; At least 1

MSW_GD_0a:	add cs:ddX[di],ax	; Change it

MSW_GD_1:	mov ax,cs:dTargdY[di]	; Target vector
		sub ax,cs:ddY[di]	; Current vector
		je MSW_GD_2		; Same, skip

		sar ax,cl		;
		jnz MSW_GD_1a		; Skip nz

		mov ax,1		; At least 1

MSW_GD_1a:	add cs:ddY[di],ax	; Change it

		; Now move

MSW_GD_2:	mov bl,cs:ddX[di]	; Step in X
		mov al,cs:ddX+1[di]	;
		cbw			;

		add bl,cs:d_frac_X[di]	; Add it
		adc ax,cs:d_X[di]	;

		mov cs:d_frac_X[di],bl	; Save fractional X

		call Wrap_X		; Clip it

		mov cs:d_X[di],ax	; Save new X

		; Move it in Y

		mov ax,cs:ddY[di]	; Disp
		add ax,cs:d_frac_Y[di]	; Posn

		mov cs:d_frac_Y[di],al	; Save fraction

		mov al,ah		; Y

		; Clip Y

		cmp al,Max_Y-6		; Below bottom ?
		ja MSW_Y_Top		; Above

		cmp al,Min_Y+6		; Above top ?
		jae MSW_Y		; No, skip

		mov al,Max_Y-6		; Bottom
		jmp s MSW_Y		; Yes

MSW_Y_Top:	mov al,Min_Y+6		; Clip

MSW_Y:		mov cs:d_Y[di],al	; Save pos

		; Save the clipping Y's

		add al,3		; Bottom
		mov cs:dBott[di],al	;

		sub al,3+3		; Top
		mov cs:dTop[di],al	;

		; Draw it, etc

		jmp MT_Show		; Show it

; Time to change direction

MSW_NewDir:	mov al,cs:optSwarm_D_R	; Time to change
		mov ah,0		;
		mov cs:dLife[di],ax	;

		; Now calc new vector
		; X

		mov bx,cs:Ship_X	; Target
		mov ax,cs:d_X[di]	; Our X
		call Calc_Offset	; Vector
		mov cx,ax		; Save
		mov si,ax		;

		; Y

		mov al,cs:Ship_Y	; Target
		sub al,cs:d_Y[di]	; Our 
		cbw			; 16-bit
		mov bx,ax		; Save dY

		; Now, we must scale these to get the required speed.

		cmp cx,0		; dX +ve ?
		jns MSW_ND_1		; Yes, skip

		neg cx			; Abs dX

MSW_ND_1:	cmp ax,0		; dY +ve ?
		jns MSW_ND_2		; Yes, skip

		neg ax			; Abs dX

MSW_ND_2:	add cx,ax		; |dx| + |dY|
		inc cx			; NOT 0 !

		; Calc the scale speed

		mov dx,0		; 32-bit
		mov ax,cs:dTargSpeed[di];

		div cx			; Calc 

		; Now scale the real dX/dY

		mov cx,ax		; Scale factor
		inc cx			; NOT ZERO !

		mov ax,si		; dX
		imul cx			; Scale it
		mov cs:dTargdX[di],ax	;

		mov ax,bx		; dY
		imul cx			; Scale it
		mov cs:dTargdY[di],ax	;

		; Done, skip

		jmp MSW_GotDir		; As above

	; Possible impact with the ship

MSW_PossHit:	add al,3+3		; Down
		cmp al,cs:dTop[di]	; Get the highest possible Y
		jb vMSW_NotHit		; No, not hit

		; The Y's are right, check the X's

		mov ax,cs:Ship_X	; The ship's position

		sub ax,16		; Back 11
		call Wrap_X		;
		mov cx,ax		;

		mov ax,cs:Ship_X	; The ship's position

		add ax,16		; Back 11
		call Wrap_X		;
		mov dx,ax		;

		mov ax,cs:d_X[di]	; X in range ?

		cmp cx,dx		; Wrapped ?
		jnc MSWPH_CheckEnd	; Yes, try another clip

		; Now try the X's

		cmp ax,cx		;
		jb vMSW_NotHit		; No, fail

		cmp ax,dx		; X in range ?
		ja vMSW_NotHit		; No, fail

		; Assume a hit

MSW_Hit:	mov al,Swarmer_Damage	; Dec the shields
		call Shield_Dec		;

		; Explode the mine

		jmp MSW_Shot		; As if shot

	; The pod is at the end, alternate clip

MSWPH_CheckEnd:	cmp ax,dx		; X<RHS
		jb MSW_Hit		; Yes, skip

		cmp ax,cx		; LHS<X
		ja MSW_Hit		; Yes, skip 

		; Not hit, skip

vMSW_NotHit:	jmp MSW_NotHit		; Skip

; Vars

Temp_X		dw 0			;
Temp_Y		db 0			;
