; The mans lowest speed

Man_Slowest	equ 8			; This slow

; This is the monster driving source

Create_Things:	mov cx,cs:nMen		; This many men

		; Create them randomly

CT_Lp:		push cx			; Save

		; Create a man

		call Create_Man		; Create a man

		; Done, next

		pop cx			; Restore

		loop CT_Lp		; Loop

		; Exit

		ret			; Done

; Create a man, used by Create_Things

Create_Man:	push di			; Save

		; Get some space

		call Get_Free		; Giz some space
		jc CM_Fail		; Failed

		; Set its vars

		call Get_Crazy_Cnt	; A random time
		mov cs:dLife[di],ax	; Save it

		; Random speed

		call Rand_32		; Random
		and al,007h		; 0 .. 7
		add al,1		; Min
		mov cs:dSpeed[di],al	;

		mov b cs:dDelay[di],1	; Start immediately

		; Setup direction

		call Rand_32		; Random
		and al,01h		;
		jnz CM_1		; 1, skip
		dec al			; -1

CM_1:		mov cs:ddX[di],al	; Set dX as 1 or -1

		; Setup cnt

		mov b cs:dCnt[di],0	; Cnt = 0

		; Setup colours

		mov ax,070Ch		; Col 0,1
		mov cs:dCol1[di],ax	;

		mov ax,0509h		; Col 2,3
		mov cs:dCol2[di],ax	;

		mov b cs:dMap_Col[di],9	; Blue

		; Setup it's hit points

		mov b cs:dHits[di],1	; Doesn't matter, never used

		; Setup it's shot routine

		mov w cs:dpShot[di],o Man_Shot; Shot routine

		; Position

		call Rand_X		; Giz a random X

		; Get its Y

		push ds			; Save
		push ax			;

		mov bx,o Mount_Ys	; Y defn
		add bx,ax		;

		mov ax,DATA		; Get the seg
		mov ds,ax		;

		mov dl,ds:[bx]		; Get the Y
		sub dl,5		; In the middle of the man

		pop ax			; Restore
		pop ds			;

		; Setup it's move routine

		mov cx,o Move_Man	; Move routine

		; Setup it's implode

		mov bx,o Frag_Implode	; Implosion

		; Add it

		call Warp_In		; Warp it in

		; Exit

CM_Fail:	pop di			; Restore
		ret			; Done

; Exit code

DT_X:		ret			; Exit

; This is the code which moves and displays fragments, etc

	; It was shown

DT_Drawn:	test b cs:Smart_Bomb_F,1; Kill visible things ?
		jz DT_Map		; No, skip

		or b cs:dFlags[di],80h	; Kill it
		jmp s DT_Map		; Done

; Draw them

Drive_Things:	call Set_EGA_Regs	; Setup, in case the first is invisible

		mov di,cs:pThings	; Point at the thing list

		mov ax,o pThings-dpNext	; Point at this ptr
		mov cs:pPrev_Thing,ax	; Save this

		cmp di,0		; Any things ?
		jz DT_X			; No, exit

		; There are creatures

		mov b cs:Action,1	; Flag that we did something

DT_Lp:		cmp di,0		; Valid ?
		jz DT_X			; No, skip

		; Time to move it ?

		dec b cs:dDelay[di]	; Time = 0
		jz DT_Move		; Yes, move it

		; Now show it

DT_Show:	call Draw_Thing		; Show it
		jnc DT_Drawn		; Yes, we showed it

		; Show it in the map

DT_Map:		mov ds,cs:VDU_Seg	; VDU Segment

		; Calc ptr

		mov bx,cs:Map_X		; X

		sar bx,1		; /8 (Scale to screen)
		sar bx,1		;
		sar bx,1		;

		add bx,160-20		; Offset it

		mov cl,bl		; Save
		and cl,07h		;

		sar bx,1		; / 8
		sar bx,1		;
		sar bx,1		;

		cmp bx,0		; Allow for wrap
		jns DT_Map_Hack		;

		lea bx,40[bx]		;

DT_Map_Hack:	add bx,cs:dMap_Ptr[di]	; Allow for Y

		; Calc bit mask

		mov ah,080h		; LHS
		shr ah,cl		; Align

		; Set the bit-mask

		mov dx,03CEh		; Set the bit-map

		mov al,08h		; BIT-MAP reg
		out dx,ax		; Set the map

		; Draw it

		mov al,cs:dMap_Col[di]	; Get the colour

		and [bx],al		; Set the colour

		; Add to the un-draw list

		dec bp			; Push it
		dec bp			;

		mov cs:[bp],bx		; Save ptr

		; Move onto the next

DT_Next:	mov cs:pPrev_Thing,di	; Save a ptr to it

		mov di,cs:dpNext[di]	; Next thing

		jmp DT_Lp		; Loop

	; Kill this man

DT_Kill:	mov ax,cs:d_X[di]	; X
		mov dl,cs:d_Y[di]	; Y

		sub dl,5		; Y

		mov bx,o Frag_Explode	; Big table
		call Gen_Frag		; Generate the fragments

		jmp s DT_Remove		; Next

; Call it's move routine

DT_Move:	mov al,cs:dSpeed[di]	; Speed
		mov cs:dDelay[di],al	;
	
		mov bx,cs:dpMove[di]	; Point at it
		call bx			; Call it
		jnc DT_Show		; Alive, show it

		; We must kill this thing

DT_Remove:	mov ax,cs:dpNext[di]	; The next one
		mov bx,cs:pPrev_Thing	; The last one

		mov cs:dpNext[bx],ax	; The last points at the next

		; Add this one to free-space

		call Put_Free		; Release di

		; Now, drive the next one

		mov di,ax		; Point at the next one

		jmp DT_Lp		; Loop

; Assert crazy-eddie

MM_Set_Crazy:	call Get_Crazy_Cnt	; Get the new delay
		mov cs:dLife[di],ax	;

		; Now, set the table ptr

		mov w cs:dfTab[di],o Crazy_Tab; Point at the table

		; Set the crazy flag

		or b cs:dFlags[di],020h	; Assert crazy

		; Save the Y

		mov al,cs:d_Y[di]	; Old height
		mov cs:dTemp1[di],al	; Save it

		; Set the sprite

		mov al,5		; Pointing right

		cmp b cs:ddX[di],0	; Left or right ?
		jns MMSC_1		; right

		mov al,9		; Pointing left

MMSC_1:		mov cs:dShape[di],al	; Man sprite

		; Set the radar colour

		mov b cs:dMap_Col[di],11; Colour

		; Move it

		jmp MM_Crazy		; Move it
		
	; Possibly a landing-pad, try it

MM_PossPad:	mov bx,o Pad_List	; Point at the list

MMPP_Lp:	mov cx,cs:[bx]		; End ?
		cmp cx,0		; 0 ?
		je MM_NotPad		; No, skip

		cmp ax,cx		; This address ?
		je MMPP_Pad		; Yes, skip

		lea bx,6[bx]		; Skip this pad

		jmp s MMPP_Lp		; Loop

	; We are above a pad, is it free ?

MMPP_Pad:	test b cs:3[bx],04h	; Get the pad occupied state
		jz MM_NotPad		; Free, ignore this pad

		; Is there a pointer to the lander ?

		mov si,cs:4[bx]		; Get the link
		cmp si,0		; Valid ?
		jz MM_NotPad		; No, ignore it

		; Now, does this lander point at this pad ?

		cmp bx,cs:dpPad[si]	; Does the lander link back ?
		jne MM_NotPad		; No, skip

		; Ok, put the lander into state 3

		mov b cs:dState[si],3	; State := 3

		; Now, we are prob. caught, kill the man

		stc			; Kill the man
		ret			; Done

; Move the man

vMM_Flags:	jmp MM_Flags		; Vector

Move_Man:	test b cs:dFlags[di],0A0h; Dead or crazy ?
		jnz vMM_Flags		; Yes, skip

		; Crazy time-out

MM_Normal:	dec w cs:dLife[di]	; Dec the time
		jz MM_Set_Crazy		; Go mad

		; Move it

		mov al,cs:dCnt[di]	; Shape cnt
		inc al			;
		mov cs:dCnt[di],al	;

		and al,03h		; 00 .. 03

		add al,3+2		; Man-shapes (+2)

		; Left or right ?

		mov ah,cs:ddX[di]	; Direction

		sub al,ah		; + 2 or -2 dep. on dirn.
		sub al,ah		;

		; al = the right sprite, don't ask how

		mov cs:dShape[di],al	; Save it

		; Move it X

		mov al,ah		; Step X
		cbw			; 16-bit
		add ax,cs:d_X[di]	; Step it

		call Wrap_X		; Clip it

		mov cs:d_X[di],ax	; Save new X

		; Now, is this a landing pad ?

		mov bx,ax		; Dup X
		sub bx,Pad_Width/2-1	; LHS of pad
		and bl,1Fh		; Mod 32 ?
		je MM_PossPad		; Possible pad

	; Get the average mountain height

MM_NotPad:	mov bx,o Mount_Ys	; Y defn
		add bx,ax		;

		mov ax,DATA		; Get the seg
		mov ds,ax		;

		mov al,ds:[bx]		; Get the Y
		dec al			; Move up slightly
		mov cs:d_Y[di],al	; Save the Y

		; Show the man

MM_Show:	mov al,cs:d_Y[di]	; Giz Y
		mov bl,al		; Save

		; Save the clipping Y's

		mov cs:dBott[di],al	; Bottom
		sub al,9		;
		mov cs:dTop[di],al	; Top

		; Calc it's map posn fn(Y)

		mov bh,0		; Y as 16-bit

		add bx,bx		; * 2

		add bx,o Rad_Div_Tab - 2*Min_Y ; Look it up

		mov ax,cs:[bx]		; Look it up

		add ax,cs:VDU_Offset	; Offset

		mov cs:dMap_Ptr[di],ax	; Save ptr

		; Draw it

		ret			; Done (nc)

	; We are crazy or shot, which ?

MM_Flags:	mov al,cs:dFlags[di]	; Get them
		test al,80h		; Dead ?
		jnz MM_Killed		; Yes, kill it

		; We are crazy, picked up ?

MM_Crazy:	mov al,cs:Ship_TOP	; Top of ship
		mov ah,cs:d_Y[di]	; Bottom of man

		cmp al,ah		; Y in range ?
		ja MMC_NH		; No, skip

		mov al,cs:Ship_BOTT	; Bottom of ship

		sub ah,9		; Move up to top of man

		cmp al,ah		; Y in range ?
		jb MMC_NH		; No, loop

		; Get the clipping X's

		mov ax,cs:d_X[di]	; X in range ?

		mov bx,cs:Ship_LHS	; LHS
		mov cx,cs:Ship_RHS	; RHS

		cmp bx,cx		; Wrapped ?
		jnc MMC_CheckEnd	; Yes, try another clip

		; Now try the X's

		cmp ax,bx		;
		jb MMC_NH		; No, fail

		cmp ax,cx		; X in range ?
		ja MMC_NH		; No, fail

		; We have been hit by the ship

		jmp s MM_Rescued	; Grab it

	; Kill this man

MM_Killed:	mov ax,cs:d_X[di]	; X
		mov dl,cs:d_Y[di]	; Y

		mov bx,o Frag_Explode	; Ptr to table
		call Gen_Frag		; Generate the fragments

		; No score

		stc			; Kill it
		ret			; Done

	; The ship is at the end, alternate clip

MMC_CheckEnd:	cmp ax,cx		; X<RHS
		jb MM_Rescued		; Yes, skip

		cmp ax,bx		; LHS<X
		ja MM_Rescued		; Yes, skip 

	; We have not been picked up

MMC_NH:		mov bx,cs:dfTab[di]	; Point at the table

		mov ax,cs:[bx]		; New Y/Time
		lea bx,2[bx]		; Move ptr

		mov cs:dfTab[di],bx	; Save new ptr

		; End ?

		cmp ax,0		; End ?
		jz MM_Exit_Crazy	; Yes, skip

		; Set the speed

		mov cs:dDelay[di],al	; Speed

		; Set the height

		add ah,cs:dTemp1[di]	; Calc Y
		mov cs:d_Y[di],ah	;

		; As above

		jmp MM_Show		; Show it

	; Yes, clear the flag

MM_Exit_Crazy:	and b cs:dFlags[di],0DFh; Clear the crazy flag

		; Reset the colour

		mov b cs:dMap_Col[di],9	; Blue

		; As above

		jmp MM_Normal		; Skip

	; Inc the score

MM_Rescued:	add w cs:Score,5	; Step the score

		inc w cs:nMen_Coll	; Another collected

		; Improve the shields

		mov al,cs:optRescue_Shield ; Inc the shields
		call Shield_Inc		;

		; Kill this man

		stc			; Kill this man
		ret			; Done

; Get a crazy-eddie time

Get_Crazy_Cnt:	call Rand_32		; Random

		and ax,01FFh		; Clip
		add ax,120		; Base delay

		ret			; Done

; Cope with a man being shot

Man_Shot:	mov ah,cs:dSpeed[si]	; Get the speed, for later

		mov al,cs:ddx[di]	; Is the laser moving the same way
		xor al,cs:ddx[si]	; As the man ?
		jns MS_Same		; Yes, skip

		; No, slow the man down

		cmp ah,Man_Slowest	; Slowest already ?
		jae MS_Change		; Yes, skip

		; Slow dowm

		inc ah			; + 1
MS_NewSpeed:	mov cs:dSpeed[si],ah	;

		; Done

MS_X:		ret			; Done

	; Same dirn, speed up

MS_Same:	dec ah			; Speed up ?
		jne MS_NewSpeed		; Yes, done

		; Done

		ret			; Done

	; Change the direction

MS_Change:	neg b cs:ddX[si]	; Change direction

		; Done, exit

		ret			; Done

; Table of time/height for a crazy lemming

Crazy_Tab	db 1,  0		; Up
		db 1, -1		;
		db 3, -2		;
		db 1, -1		;

		db 4,  0		; Up again
		db 1, -2		;
		db 1, -4		;
		db 2, -6		;
		db 3, -7		;
		db 2, -6		;
		db 1, -4		;
		db 1, -2		;

		db 4,  0		;
		db 2, -3		;
		db 2, -6		;
		db 3, -8		;
		db 4, -9		;
		db 3, -8		;
		db 2, -6		;
		db 2, -3		;
		db 4,  0		;

		db 1, -3		;
		db 1, -6		;
		db 1, -9		;
		db 1,-11		;
		db 1,-13		;
		db 1,-15		;
		db 1,-16		;
		db 1,-17		;
		db 2,-18		;

		db 4,-19		;

		db 2,-18		;
		db 1,-17		;
		db 1,-16		;
		db 1,-15		;
		db 1,-13		;
		db 1,-11		;
		db 1, -9		;
		db 1, -6		;
		db 1, -3		;
		db 1, -0		;
		db 1,  1		;
		db 1,  2		;
		db 2,  3		;
		db 1,  2		;
		db 1,  1		;

		db 1, -4		;
		db 1, -8		;
		db 1,-12		;
		db 1,-16		;
		db 1,-19		;
		db 1,-22		;
		db 1,-25		;
		db 1,-27		;
		db 1,-29		;
		db 1,-31		;
		db 2,-32		;
		db 3,-33		;
		db 4,-34		;
		db 5,-35		;
		db 6,-36		;

		db 8,-37		;

		db 6,-36		; Down
		db 5,-35		;
		db 4,-34		;
		db 3,-33		;
		db 2,-32		;
		db 1,-31		;
		db 1,-29		;
		db 1,-27		;
		db 1,-25		;
		db 1,-22		;
		db 1,-19		;
		db 1,-16		;
		db 1,-12		;
		db 1, -8		;
		db 1, -4		;
		db 1, -0		;
		db 1,  2		;
		db 1,  3		;
		db 2,  4		;
		db 1,  3		;
		db 1,  2		;
		db 1,  1		;

		db 0,0			; End

		include lander.inc	; The landers

		include bomber.inc	; The bomber code

		include pod_etc.inc	; The pod and swarmer code

		include baiter.inc	; The baiter

	; Show the thing

MT_Show:	mov bl,cs:d_Y[di]	; Get Y

		; Calc it's map posn fn(Y)

		mov bh,0		; Y as 16-bit

		add bx,bx		; * 2

		add bx,o Rad_Div_Tab - 2*Min_Y ; Look it up

		mov ax,cs:[bx]		; Look it up

		add ax,cs:VDU_Offset	; Offset

		mov cs:dMap_Ptr[di],ax	; Save ptr

		; Draw it

		ret			; Done (nc)

	; Kill this thing

MT_Shot:	mov ax,cs:d_X[di]	; X
		mov dl,cs:d_Y[di]	; Y

		mov bx,o Frag_Explode	; Ptr to table
		call Gen_Frag		; Generate the fragments

		; No score

		stc			; Kill it
		ret			; Done

; Cope with a thing being shot - if in a power-up period, just kill it

Thing_Shot:	test w cs:Magnum_Shots,-1 ; Any left ?
		jnz TS_KillIt		  ; Yes, skip

		; Dec its hit count

		mov al,cs:dHits[si]	; Dec the hits
		dec al			;

		jz TS_KillIt		; Skip if dead

		mov cs:dHits[si],al	; Store hits

		ret			; Done, exit

	; Kill the thing

TS_KillIt:	or b cs:dFlags[si],080h	; Assert shot flag

		ret			; Done

; Initiallise the radar table

Init_Radar:	mov di,o Rad_Div_Tab	; Point at it (Min_Y)

		; Divide factor

		mov ax,cs:VDU_Width	; Y_Step

		mov cx,9		; * 9
		imul cx			;

		mov cx,o Rad_Div_End	; End of table

		mov bl,5		; Divide factor
		mov bh,bl		;

IR_Lp:		mov cs:[di],ax		; Store Y
		lea di,2[di]		;

		; Same again ?

		dec bl			; One more done
		jnz IR_1		; Skip

		; Next Y

		add ax,cs:VDU_Width	; Move down
		mov bl,bh		; Scale

		; Next Y
	
IR_1:		cmp di,cx		; End ?
		jne IR_Lp		; No, loop

		ret			; Done

; Variables

		align 2			; Even

pPrev_Thing	dw 0			; Ptr to the previous thing

Rad_Div_Tab	dw (256-Min_Y) dup (0)	; Look-up the radar Y
Rad_Div_End	equ this byte		; End

nMen		dw 0			; The number of men on this sheet
nMen_Coll	dw 0			; The number collected
